﻿// CodeGear C++Builder
// Copyright (c) 1995, 2017 by Embarcadero Technologies, Inc.
// All rights reserved

// (DO NOT EDIT: machine generated header) 'LogError.pas' rev: 33.00 (Windows)

#ifndef LogerrorHPP
#define LogerrorHPP

#pragma delphiheader begin
#pragma option push
#pragma option -w-      // All warnings off
#pragma option -Vx      // Zero-length empty class member 
#pragma pack(push,8)
#include <System.hpp>
#include <SysInit.hpp>
#include <Winapi.Windows.hpp>
#include <Winapi.Messages.hpp>
#include <System.Classes.hpp>
#include <Vcl.Graphics.hpp>
#include <System.SysUtils.hpp>
#include <Vcl.Controls.hpp>
#include <Vcl.Forms.hpp>
#include <Vcl.Dialogs.hpp>
#include <LogBase.hpp>
#include <SMMapFile.hpp>

//-- user supplied -----------------------------------------------------------

namespace Logerror
{
//-- forward type declarations -----------------------------------------------
class DELPHICLASS TSMExceptionLog;
//-- type declarations -------------------------------------------------------
enum DECLSPEC_DENUM TSMLAOption : unsigned char { laShowSendEMail, laShowSupportLink, laShowSourceLine };

typedef System::Set<TSMLAOption, TSMLAOption::laShowSendEMail, TSMLAOption::laShowSourceLine> TSMLAOptions;

enum DECLSPEC_DENUM TSMLErrorDialog : unsigned char { edNone, edStandard, edExtended };

enum DECLSPEC_DENUM TSMLFormat : unsigned char { lfDate, lfTime, lfPhysAddress, lfExceptionClassName, lfMessage, lfSeparator, lfSourceLine, lfApplication, lfActiveControl, lfComputerInfo, lfOSInfo, lfCPUInfo, lfMemoryInfo, lfVideoCard };

typedef System::Set<TSMLFormat, TSMLFormat::lfDate, TSMLFormat::lfVideoCard> TSMLFormats;

enum DECLSPEC_DENUM TSMExceptionStandard : unsigned char { efAbort, efOutOfMemory, efInOutError, efIntError, efDivByZero, efRangeError, efIntOverflow, efMathError, efInvalidOp, efZeroDivide, efOverflow, efUnderflow, efInvalidPointer, efInvalidCast, efConvertError, efAccessViolation, efPrivilege, efStackOverflow, efControlC, efVariantError, efPropReadOnly, efPropWriteOnly, efExternalException, efAssertionFailed, efAbstractError, efIntfCastError, efInvalidContainer, efInvalidInsert, efPackageError, efWin32Error };

typedef System::Set<TSMExceptionStandard, TSMExceptionStandard::efAbort, TSMExceptionStandard::efWin32Error> TSMExceptionStandards;

enum DECLSPEC_DENUM TSMExceptionClass : unsigned char { efStreamError, efFCreateError, efFOpenError, efFilerError, efReadError, efWriteError, efClassNotFound, efMethodNotFound, efInvalidImage, efResNotFound, efListError, efBitsError, efStringListError, efComponentError, efParserError, efOutOfResources, efInvalidOperation, efThread };

typedef System::Set<TSMExceptionClass, TSMExceptionClass::efStreamError, TSMExceptionClass::efThread> TSMExceptionClasses;

enum DECLSPEC_DENUM TSMExceptionGraphic : unsigned char { efInvalidGraphic, efInvalidGraphicOperation };

typedef System::Set<TSMExceptionGraphic, TSMExceptionGraphic::efInvalidGraphic, TSMExceptionGraphic::efInvalidGraphicOperation> TSMExceptionGraphics;

typedef void __fastcall (__closure *TSMLSaveExceptionEvent)(System::TObject* Sender, System::Sysutils::Exception* E, System::UnicodeString &LogText, bool &Accept);

class PASCALIMPLEMENTATION TSMExceptionLog : public Logbase::TSMLogBase
{
	typedef Logbase::TSMLogBase inherited;
	
private:
	bool InternalProcessing;
	Vcl::Forms::TExceptionEvent FoldOnException;
	Vcl::Forms::TExceptionEvent FOnException;
	TSMLSaveExceptionEvent FOnSaveException;
	TSMLErrorDialog FErrorDialog;
	TSMExceptionStandards FFilterStandard;
	TSMExceptionClasses FFilterClasses;
	TSMExceptionGraphics FFilterGraphics;
	TSMLFormats FFormats;
	TSMLAOptions FOptions;
	Smmapfile::TSMMapFile* FMapFile;
	void __fastcall ActiveWeb(System::TObject* Sender);
	void __fastcall ActivateMail(System::TObject* Sender, bool IncludeScreenshot);
	
protected:
	void __fastcall DoException(System::TObject* Sender, System::Sysutils::Exception* E);
	
public:
	__fastcall virtual TSMExceptionLog(System::Classes::TComponent* AOwner);
	__fastcall virtual ~TSMExceptionLog();
	System::UnicodeString __fastcall GetFormattedSource();
	System::UnicodeString __fastcall GetApplicationDetails();
	System::UnicodeString __fastcall GetActiveControlDetails();
	System::UnicodeString __fastcall GetComputerInfo();
	System::UnicodeString __fastcall GetMemoryInfo();
	System::UnicodeString __fastcall GetOSInfo();
	System::UnicodeString __fastcall GetCPUInfo(bool IncludeSpeed);
	System::UnicodeString __fastcall GetVideoCardInfo();
	__property Smmapfile::TSMMapFile* MapFile = {read=FMapFile, write=FMapFile};
	
__published:
	__property TSMLErrorDialog ErrorDialog = {read=FErrorDialog, write=FErrorDialog, default=2};
	__property TSMExceptionStandards FilterStandard = {read=FFilterStandard, write=FFilterStandard, default=1073741823};
	__property TSMExceptionClasses FilterClasses = {read=FFilterClasses, write=FFilterClasses, default=262143};
	__property TSMExceptionGraphics FilterGraphics = {read=FFilterGraphics, write=FFilterGraphics, default=3};
	__property TSMLFormats Formats = {read=FFormats, write=FFormats, default=951};
	__property TSMLAOptions Options = {read=FOptions, write=FOptions, default=3};
	__property Vcl::Forms::TExceptionEvent OnException = {read=FOnException, write=FOnException};
	__property TSMLSaveExceptionEvent OnSaveException = {read=FOnSaveException, write=FOnSaveException};
};


//-- var, const, procedure ---------------------------------------------------
}	/* namespace Logerror */
#if !defined(DELPHIHEADER_NO_IMPLICIT_NAMESPACE_USE) && !defined(NO_USING_NAMESPACE_LOGERROR)
using namespace Logerror;
#endif
#pragma pack(pop)
#pragma option pop

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// LogerrorHPP
